%% Setup continuous time system matrices
function [P_gen_continuous, P_continuous] = define_system
M = 20;
m = 1;
b = .3;
k = 32;

A = [-b/M -k/M b/M k/M;
     1 0 0 0;
     b/m k/m -b/m -k/m;
     0 0 1 0];
B = [1/M;0;0;0];

Bw = [zeros(4,2) B];

% w <-> {r, n , d}
% z <-> {p1, u0 = u + d, e}

% R to U -> position (2,1)
% R to E -> position (3,1)
% R to P1 -> position (1,1)

Cz = [0 1 0 0; 0 0 0 0; 0 -1 0 0]; 
Dzw = [0 0 0; 0 0 1; 1 0 0];
Dzu = [0; 1; 0];

Cy = [0 0 0 0; 0 0 0 1];
Dyw = [1 0 0; 0 1 0];
Dyu = zeros(2,1);

% Create  a continuous time statespace model for the generalized plant model
P_gen_continuous = ss(A,[Bw B],[Cz;Cy],[Dzw Dzu;Dyw Dyu]);
P_continuous = ss(A, B, [0 0 0 1], 0);