% Given a (potentially unstable) plant G=[G11 G12; G21 G22], where
% G11 has size (nz,nw), find stable transfer matrices T1, T2, T3
% such that every internally stable transfer function G11+G12/(I-C*G22)*C*G21
% is parametrized by Tzw+T*Q*T21 for some stable Q
function [Tzw,Tzr,Tew,Knom_data]=qcvx_q_parametrization( P , nz, nw, flag_ref )
% This function is from the original version of Qtool by A. Wernrud

if nargin<3, nw=1; end,
if nargin<2, nz=1; end,
%ssG=ss(G,'min');
[A,B,C,D,ts] = ssdata(P);

nu = size(B,2)-nw;
ny = size(C,1)-nz;
Bw = B(:,1:nw);
Bu = B(:,nw+1:end);
Cz = C(1:nz,:);
Cy = C(nz+1:end,:);
Dzw = D(1:nz,1:nw);
Dzu = D(1:nz,nw+1:end);
Dyw = D(nz+1:end,1:nw);
Dyu = D(nz+1:end,nw+1:end);
nx = size(A,1);

L = dlqr(A,Bu,1*eye(nx),1*eye(nu));
K = dlqr(A',Cy',eye(nx),eye(ny))';

if flag_ref==1
    AT = [A -Bu*L;K(:,2:end)*Cy(2:end,:) A-Bu*L-K(:,2:end)*Cy(2:end,:)];
    BT = [Bw;K*Dyw];BT = BT(:,1);
    CT = [Cz -Dzu*L];
    E= CT(1,:)*pinv(eye(size(AT,1))-AT);
    r = E*BT;
    E=E(:,nx+1:end);
    K(:,1) = pinv(E)*(1-Dzw(1,1)-r);
end
AT = [A -Bu*L;K*Cy A-Bu*L-K*Cy];
Tzw = ss(AT,[Bw;K*Dyw],[Cz -Dzu*L],Dzw,ts);
Tew = ss(AT,[Bw;K*Dyw],[Cy -Cy],Dyw,ts);
Tzr = ss(AT,[Bu;Bu],[Cz -Dzu*L],Dzu,ts);

Knom_data.K = K;
Knom_data.C2 = Cy;
Knom_data.B2 = Bu;
Knom_data.D22 = 0;
Knom_data.L=L;
Knom_data.A=A;


  