% Computes the controller by augmenting the nominal controller with Q
function [K1,K2,Kd] = qcvx_recover_controller(Knom_data, Q)
   K = Knom_data.K;
   C2 = Knom_data.C2;
   B2 = Knom_data.B2; 
   D22 = Knom_data.D22; 
   L = Knom_data.L;
   A = Knom_data.A;
   
   WW = [zeros(size(L,1),size(K,2)) eye(size(L,1))];
   nominal_controller = ss([A-B2*L-K*C2],[K B2],[-L ;-C2], [WW; eye(size(C2,1)) zeros(size(C2,1),size(WW,2)-size(C2,1))],Q.ts);
   Kd = lft(nominal_controller,Q,size(Q,1),size(Q,2));
   K1 = Kd(1,1);
   K2 = Kd(1,2);
