% Creates a discrete-time Q_basis consisting of transfer function matrices
% where the only non-zero element is of the form 1, z^-1, z^-2, ...
function Q_basis = create_Q_basis(Ts, Qsize, N)

zinv = tf(1, [1 0],Ts); % define the transfer function z^-1

Q_basis = cell(N*prod(Qsize), 1); % Cell array containing transfer matrices for Q-basis

k = 0;
for tf_n = 1:Qsize(1)
    for tf_m = 1:Qsize(2)
        for ell=0:N-1
            k = k + 1;
            
            Q_basis{k} = ss(zeros(Qsize));
            Q_basis{k}(tf_n, tf_m) = zinv^ell;
        end
    end
end